(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
(function(){
    var root = this;

    //消息填充位，补足长度。
    function fillString(str){
        var blockAmount = ((str.length + 8) >> 6) + 1,
            blocks = [],
            i;

        for(i = 0; i < blockAmount * 16; i++){
            blocks[i] = 0;
        }
        for(i = 0; i < str.length; i++){
            blocks[i >> 2] |= str.charCodeAt(i) << (24 - (i & 3) * 8);
        }
        blocks[i >> 2] |= 0x80 << (24 - (i & 3) * 8);
        blocks[blockAmount * 16 - 1] = str.length * 8;

        return blocks;
    }

    //将输入的二进制数组转化为十六进制的字符串。
    function binToHex(binArray){
        var hexString = "0123456789abcdef",
            str = "",
            i;

        for(i = 0; i < binArray.length * 4; i++){
            str += hexString.charAt((binArray[i >> 2] >> ((3 - i % 4) * 8 + 4)) & 0xF) +
                    hexString.charAt((binArray[i >> 2] >> ((3 - i % 4) * 8  )) & 0xF);
        }

        return str;
    }

    //核心函数，输出为长度为5的number数组，对应160位的消息摘要。
    function coreFunction(blockArray){
        var w = [],
            a = 0x67452301,
            b = 0xEFCDAB89,
            c = 0x98BADCFE,
            d = 0x10325476,
            e = 0xC3D2E1F0,
            olda,
            oldb,
            oldc,
            oldd,
            olde,
            t,
            i,
            j;

        for(i = 0; i < blockArray.length; i += 16){  //每次处理512位 16*32
            olda = a;
            oldb = b;
            oldc = c;
            oldd = d;
            olde = e;

            for(j = 0; j < 80; j++){  //对每个512位进行80步操作
                if(j < 16){
                    w[j] = blockArray[i + j];
                }else{
                    w[j] = cyclicShift(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
                }
                t = modPlus(modPlus(cyclicShift(a, 5), ft(j, b, c, d)), modPlus(modPlus(e, w[j]), kt(j)));
                e = d;
                d = c;
                c = cyclicShift(b, 30);
                b = a;
                a = t;
            }

            a = modPlus(a, olda);
            b = modPlus(b, oldb);
            c = modPlus(c, oldc);
            d = modPlus(d, oldd);
            e = modPlus(e, olde);
        }

        return [a, b, c, d, e];
    }

    //根据t值返回相应得压缩函数中用到的f函数。
    function ft(t, b, c, d){
        if(t < 20){
            return (b & c) | ((~b) & d);
        }else if(t < 40){
            return b ^ c ^ d;
        }else if(t < 60){
            return (b & c) | (b & d) | (c & d);
        }else{
            return b ^ c ^ d;
        }
    }

    //根据t值返回相应得压缩函数中用到的K值。
    function kt(t){
        return (t < 20) ?  0x5A827999 :
                (t < 40) ? 0x6ED9EBA1 :
                (t < 60) ? 0x8F1BBCDC : 0xCA62C1D6;
    }

    //模2的32次方加法，因为JavaScript的number是双精度浮点数表示，所以将32位数拆成高16位和低16位分别进行相加
    function modPlus(x, y){
        var low = (x & 0xFFFF) + (y & 0xFFFF),
            high = (x >> 16) + (y >> 16) + (low >> 16);

        return (high << 16) | (low & 0xFFFF);
    }

    //对输入的32位的num二进制数进行循环左移 ,因为JavaScript的number是双精度浮点数表示，所以移位需需要注意
    function cyclicShift(num, k){
        return (num << k) | (num >>> (32 - k));
    }

    //主函数根据输入的消息字符串计算消息摘要，返回十六进制表示的消息摘要
    function sha1(s){
        return binToHex(coreFunction(fillString(s)));
    }

    // support AMD and Node
    if(typeof define === "function" && typeof define.amd){
        define(function(){
            return sha1;
        });
    }else if(typeof exports !== 'undefined') {
        if(typeof module !== 'undefined' && module.exports) {
          exports = module.exports = sha1;
        }
        exports.sha1 = sha1;
    } else {
        root.sha1 = sha1;
    }

}).call(this);
},{}],2:[function(require,module,exports){
(function() {
  'use strict';

  if (self.fetch) {
    return
  }

  function normalizeName(name) {
    if (typeof name !== 'string') {
      name = String(name)
    }
    if (/[^a-z0-9\-#$%&'*+.\^_`|~]/i.test(name)) {
      throw new TypeError('Invalid character in header field name')
    }
    return name.toLowerCase()
  }

  function normalizeValue(value) {
    if (typeof value !== 'string') {
      value = String(value)
    }
    return value
  }

  function Headers(headers) {
    this.map = {}

    if (headers instanceof Headers) {
      headers.forEach(function(value, name) {
        this.append(name, value)
      }, this)

    } else if (headers) {
      Object.getOwnPropertyNames(headers).forEach(function(name) {
        this.append(name, headers[name])
      }, this)
    }
  }

  Headers.prototype.append = function(name, value) {
    name = normalizeName(name)
    value = normalizeValue(value)
    var list = this.map[name]
    if (!list) {
      list = []
      this.map[name] = list
    }
    list.push(value)
  }

  Headers.prototype['delete'] = function(name) {
    delete this.map[normalizeName(name)]
  }

  Headers.prototype.get = function(name) {
    var values = this.map[normalizeName(name)]
    return values ? values[0] : null
  }

  Headers.prototype.getAll = function(name) {
    return this.map[normalizeName(name)] || []
  }

  Headers.prototype.has = function(name) {
    return this.map.hasOwnProperty(normalizeName(name))
  }

  Headers.prototype.set = function(name, value) {
    this.map[normalizeName(name)] = [normalizeValue(value)]
  }

  Headers.prototype.forEach = function(callback, thisArg) {
    Object.getOwnPropertyNames(this.map).forEach(function(name) {
      this.map[name].forEach(function(value) {
        callback.call(thisArg, value, name, this)
      }, this)
    }, this)
  }

  function consumed(body) {
    if (body.bodyUsed) {
      return Promise.reject(new TypeError('Already read'))
    }
    body.bodyUsed = true
  }

  function fileReaderReady(reader) {
    return new Promise(function(resolve, reject) {
      reader.onload = function() {
        resolve(reader.result)
      }
      reader.onerror = function() {
        reject(reader.error)
      }
    })
  }

  function readBlobAsArrayBuffer(blob) {
    var reader = new FileReader()
    reader.readAsArrayBuffer(blob)
    return fileReaderReady(reader)
  }

  function readBlobAsText(blob) {
    var reader = new FileReader()
    reader.readAsText(blob)
    return fileReaderReady(reader)
  }

  var support = {
    blob: 'FileReader' in self && 'Blob' in self && (function() {
      try {
        new Blob();
        return true
      } catch(e) {
        return false
      }
    })(),
    formData: 'FormData' in self,
    arrayBuffer: 'ArrayBuffer' in self
  }

  function Body() {
    this.bodyUsed = false


    this._initBody = function(body) {
      this._bodyInit = body
      if (typeof body === 'string') {
        this._bodyText = body
      } else if (support.blob && Blob.prototype.isPrototypeOf(body)) {
        this._bodyBlob = body
      } else if (support.formData && FormData.prototype.isPrototypeOf(body)) {
        this._bodyFormData = body
      } else if (!body) {
        this._bodyText = ''
      } else if (support.arrayBuffer && ArrayBuffer.prototype.isPrototypeOf(body)) {
        // Only support ArrayBuffers for POST method.
        // Receiving ArrayBuffers happens via Blobs, instead.
      } else {
        throw new Error('unsupported BodyInit type')
      }
    }

    if (support.blob) {
      this.blob = function() {
        var rejected = consumed(this)
        if (rejected) {
          return rejected
        }

        if (this._bodyBlob) {
          return Promise.resolve(this._bodyBlob)
        } else if (this._bodyFormData) {
          throw new Error('could not read FormData body as blob')
        } else {
          return Promise.resolve(new Blob([this._bodyText]))
        }
      }

      this.arrayBuffer = function() {
        return this.blob().then(readBlobAsArrayBuffer)
      }

      this.text = function() {
        var rejected = consumed(this)
        if (rejected) {
          return rejected
        }

        if (this._bodyBlob) {
          return readBlobAsText(this._bodyBlob)
        } else if (this._bodyFormData) {
          throw new Error('could not read FormData body as text')
        } else {
          return Promise.resolve(this._bodyText)
        }
      }
    } else {
      this.text = function() {
        var rejected = consumed(this)
        return rejected ? rejected : Promise.resolve(this._bodyText)
      }
    }

    if (support.formData) {
      this.formData = function() {
        return this.text().then(decode)
      }
    }

    this.json = function() {
      return this.text().then(JSON.parse)
    }

    return this
  }

  // HTTP methods whose capitalization should be normalized
  var methods = ['DELETE', 'GET', 'HEAD', 'OPTIONS', 'POST', 'PUT']

  function normalizeMethod(method) {
    var upcased = method.toUpperCase()
    return (methods.indexOf(upcased) > -1) ? upcased : method
  }

  function Request(input, options) {
    options = options || {}
    var body = options.body
    if (Request.prototype.isPrototypeOf(input)) {
      if (input.bodyUsed) {
        throw new TypeError('Already read')
      }
      this.url = input.url
      this.credentials = input.credentials
      if (!options.headers) {
        this.headers = new Headers(input.headers)
      }
      this.method = input.method
      this.mode = input.mode
      if (!body) {
        body = input._bodyInit
        input.bodyUsed = true
      }
    } else {
      this.url = input
    }

    this.credentials = options.credentials || this.credentials || 'omit'
    if (options.headers || !this.headers) {
      this.headers = new Headers(options.headers)
    }
    this.method = normalizeMethod(options.method || this.method || 'GET')
    this.mode = options.mode || this.mode || null
    this.referrer = null

    if ((this.method === 'GET' || this.method === 'HEAD') && body) {
      throw new TypeError('Body not allowed for GET or HEAD requests')
    }
    this._initBody(body)
  }

  Request.prototype.clone = function() {
    return new Request(this)
  }

  function decode(body) {
    var form = new FormData()
    body.trim().split('&').forEach(function(bytes) {
      if (bytes) {
        var split = bytes.split('=')
        var name = split.shift().replace(/\+/g, ' ')
        var value = split.join('=').replace(/\+/g, ' ')
        form.append(decodeURIComponent(name), decodeURIComponent(value))
      }
    })
    return form
  }

  function headers(xhr) {
    var head = new Headers()
    var pairs = xhr.getAllResponseHeaders().trim().split('\n')
    pairs.forEach(function(header) {
      var split = header.trim().split(':')
      var key = split.shift().trim()
      var value = split.join(':').trim()
      head.append(key, value)
    })
    return head
  }

  Body.call(Request.prototype)

  function Response(bodyInit, options) {
    if (!options) {
      options = {}
    }

    this._initBody(bodyInit)
    this.type = 'default'
    this.status = options.status
    this.ok = this.status >= 200 && this.status < 300
    this.statusText = options.statusText
    this.headers = options.headers instanceof Headers ? options.headers : new Headers(options.headers)
    this.url = options.url || ''
  }

  Body.call(Response.prototype)

  Response.prototype.clone = function() {
    return new Response(this._bodyInit, {
      status: this.status,
      statusText: this.statusText,
      headers: new Headers(this.headers),
      url: this.url
    })
  }

  Response.error = function() {
    var response = new Response(null, {status: 0, statusText: ''})
    response.type = 'error'
    return response
  }

  var redirectStatuses = [301, 302, 303, 307, 308]

  Response.redirect = function(url, status) {
    if (redirectStatuses.indexOf(status) === -1) {
      throw new RangeError('Invalid status code')
    }

    return new Response(null, {status: status, headers: {location: url}})
  }

  self.Headers = Headers;
  self.Request = Request;
  self.Response = Response;

  self.fetch = function(input, init) {
    return new Promise(function(resolve, reject) {
      var request
      if (Request.prototype.isPrototypeOf(input) && !init) {
        request = input
      } else {
        request = new Request(input, init)
      }

      var xhr = new XMLHttpRequest()

      function responseURL() {
        if ('responseURL' in xhr) {
          return xhr.responseURL
        }

        // Avoid security warnings on getResponseHeader when not allowed by CORS
        if (/^X-Request-URL:/m.test(xhr.getAllResponseHeaders())) {
          return xhr.getResponseHeader('X-Request-URL')
        }

        return;
      }

      xhr.onload = function() {
        var status = (xhr.status === 1223) ? 204 : xhr.status
        if (status < 100 || status > 599) {
          reject(new TypeError('Network request failed'))
          return
        }
        var options = {
          status: status,
          statusText: xhr.statusText,
          headers: headers(xhr),
          url: responseURL()
        }
        var body = 'response' in xhr ? xhr.response : xhr.responseText;
        resolve(new Response(body, options))
      }

      xhr.onerror = function() {
        reject(new TypeError('Network request failed'))
      }

      xhr.open(request.method, request.url, true)

      if (request.credentials === 'include') {
        xhr.withCredentials = true
      }

      if ('responseType' in xhr && support.blob) {
        xhr.responseType = 'blob'
      }

      request.headers.forEach(function(value, name) {
        xhr.setRequestHeader(name, value)
      })

      xhr.send(typeof request._bodyInit === 'undefined' ? null : request._bodyInit)
    })
  }
  self.fetch.polyfill = true
})();

},{}],3:[function(require,module,exports){
/**
 *
 * @param strUrl {string} [strUrl] - A valid Url to parse. If not specified then current URL is taken. Make sure that query string tokens are encoded (use encodeURIComponent)
 * @returns {{url: String, tokens: {}, has: Function, get: Function, getAll: Function, log: Function}}
 * @constructor
 */
function QS(strUrl) {
  var _qs = {
    /** @property {string} version - Current library version */
    version: QS.version,

    /** @property {string} url - Url to parse */
    url: (strUrl || (window && window.location.href)),

    /** @property {string} url - Query string tokens object */
    tokens: {},

    /**
     * Checks if url contains specific query string token's key
     * @name has
     * @example
     * // returns true
     * QS('http://www.somedomain.com/somepage?foo=bar').has('foo');
     * @param {string} strKey - Query string token's key to search
     * @returns {boolean} True if key exists, false otherwise
     */
    has: function (strKey) {
      return _qs.tokens.hasOwnProperty(strKey);
    },

    /**
     * Gets query string token's decoded value
     * @name get
     * @example
     * // returns 'bar'
     * QS('http://www.somedomain.com/somepage?foo=bar').get('foo');
     * @param {string} strKey - Query string token's key to search
     * @returns {object} Query string token's value if key exists, otherwise null
     */
    get: function (strKey) {
      return _qs.tokens[strKey];
    },

    /**
     * Gets all query string tokens object
     * @name getAll
     * @example
     * // returns {foo: "bar"}
     * QS('http://www.somedomain.com/somepage?foo=bar').getAll();
     * @returns {*} Query string keys & values collection
     */
    getAll: function () {
      return _qs.tokens;
    },

    /**
     * Sets (update or insert) a query string token and then updates URL property
     * @name set
     * @param {string} strKey - Query string key name to set (update or insert)
     * @param {object} objValue - Query string value (plain, decoded)
     * @example
     * QS('http://www.somedomain.com/somepage?foo=bar').set('dom', true);
     * @returns QS (for chaining purposes)
     */
    set: function (strKey, objValue) {
      _qs.tokens[strKey] = objValue;
      _updateURL();
      return _qs;
    },

    /**
     * Removes a query string token from URL
     * @name remove
     * @param {string} strKey - Query string key name to remove
     * @example
     * QS('http://www.somedomain.com/somepage?foo=bar').remove('foo');
     * @returns QS (for chaining purposes)
     */
    remove: function (strKey) {
      delete _qs.tokens[strKey];
      _updateURL();
      return _qs;
    },

    /**
     * Changes browser location to QS url (usually after manipulating query string tokens)
     * @name go
     * @example
     * QS('http://www.somedomain.com/somepage?foo=bar').set('rob', 5).go();
     */
    go: function () {
      document.location.href = _qs.url;
    },

    /**
     * Logs all query string tokens to browser's console
     * @name log
     * @example
     * QS('http://www.somedomain.com/somepage?foo=bar').log();
     */
    log: function () {
      console.log(_qs.tokens);
    }
  };

  // Cast values of tokens:
  function _cast(objValue) {
    // Null value:
    if (objValue === null) {
      return;
    }

    // Numeric value:
    if (!isNaN(objValue) && Number(objValue).toString() === objValue) {
      return Number(objValue);
    }

    // Boolean value:
    if (objValue === 'true') {
      return true;
    }

    if (objValue === 'false') {
      return false;
    }

    // Undefined:
    if (objValue === 'undefined') {
      return undefined;
    }

    // Null value:
    if (objValue === 'null') {
      return null;
    }

    // String value:
    return objValue;
  }

  QS.version = '0.3.10';

  /**
   * Update url property (usually after manipulating query string tokens)
   * @name _updateURL
   * @ignore
   * @private
   */
  function _updateURL() {
    var strUpdatedUrl = '',
      strBaseURL = _qs.url.substr(0, (_qs.url.indexOf('?') > 0 && _qs.url.indexOf('?')) || _qs.url.length),
      strHash = _qs.url.indexOf('#') > 0 && _qs.url.substr(_qs.url.indexOf('#'));
      arrTokens = [];

    // Compose query strings:
    for (var key in _qs.tokens) {
      if (_qs.tokens.hasOwnProperty(key)) {
        arrTokens.push(encodeURIComponent(key) + (_qs.tokens[key] ? '=' + encodeURIComponent(_qs.tokens[key]) : ''));
      }
    }

    // Set updated url to base + qs + hash:
    strUpdatedUrl = strBaseURL;
    strUpdatedUrl += (arrTokens.length > 0 ? '?' + arrTokens.join('&') : '');
    strUpdatedUrl += (strHash && strHash.length > 0 ? strHash : '');

    _qs.url = strUpdatedUrl;
  }

  /**
   * Extracts all query string tokens from url
   * @constructs
   */
  (function _init() {
    var re = /[?&]([^=&#]+)(?:=([^&#]+))?/g,
      match;

    match = re.exec(_qs.url);
    while (match !== null) {
      // Register _qs keys as object's properties:
      _qs.tokens[decodeURIComponent(match[1])] = match[2] ? _cast(decodeURIComponent(match[2])) : null;
      match = re.exec(_qs.url);
    }

    // We update URL to apply encoded query string token, if user hasn't done it:
    _updateURL();
  })();

  // Reveal methods & properties:
  return _qs;
}

},{}],4:[function(require,module,exports){
'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Util = require('./Util');

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Translator = (function () {
    function Translator(alias) {
        var key = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];
        var uri = arguments.length <= 2 || arguments[2] === undefined ? '' : arguments[2];

        _classCallCheck(this, Translator);

        this.langs = [];
        this.cache = {};
        this.provider = Translator.createProvider(alias, key, uri);
    }

    _createClass(Translator, [{
        key: 'getLangs',
        value: function getLangs() {
            if (this.langs.length) {
                return Promise.resolve(this.langs);
            }

            return this.provider.getLangs();
        }
    }, {
        key: 'translate',
        value: function translate(text, to, from) {
            var hash = _Util2.default.sha1(text);
            var lang = _Util2.default.composeLangsAlias(from, to);

            if (typeof this.cache[lang] !== 'undefined' && typeof this.cache[lang][hash] !== 'undefined') {
                return Promise.resolve(this.cache[lang][hash]);
            }

            return this.provider.translate(text, to, from);
        }
    }, {
        key: 'lookup',
        value: function lookup() {
            var text = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];

            var _this = this;

            var to = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];
            var from = arguments.length <= 2 || arguments[2] === undefined ? '' : arguments[2];

            var lang = _Util2.default.composeLangsAlias(from, to);

            return this.getLangs().then(function (langs) {
                _this.langs = langs;

                if (!_this.provider.supports(langs, to, from)) {
                    return null;
                }

                return _this.translate(text, to, from);
            }).then(function (trans) {
                if (typeof _this.cache[lang] === 'undefined') {
                    _this.cache[lang] = {};
                }
                _this.cache[lang][_Util2.default.sha1(text)] = trans;

                return trans;
            });
        }
    }], [{
        key: 'addProvider',
        value: function addProvider(alias, Factory) {
            Translator.providerMap[alias] = Factory;
        }
    }, {
        key: 'createProvider',
        value: function createProvider(alias, key, uri) {
            if (typeof Translator.providerMap[alias] === 'undefined') {
                return null;
            }

            var Factory = Translator.providerMap[alias];

            return new Factory(key, uri);
        }
    }]);

    return Translator;
})();

Translator.providerMap = {};

exports.default = Translator;
},{"./Util":5}],5:[function(require,module,exports){
'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Util = (function () {
    function Util() {
        _classCallCheck(this, Util);
    }

    _createClass(Util, null, [{
        key: 'addHelper',
        value: function addHelper(alias, helper) {
            Util.helpers[alias] = helper;
        }
    }, {
        key: 'getHelper',
        value: function getHelper(alias) {
            return Util.helpers[alias];
        }
    }, {
        key: 'stringify',
        value: function stringify(data) {
            return '?' + Util.getHelper('stringify')(data);
        }
    }, {
        key: 'sha1',
        value: function sha1(text) {
            return Util.getHelper('sha1')(text);
        }
    }, {
        key: 'composeLangsAlias',
        value: function composeLangsAlias(from, to) {
            return from + '-' + to;
        }
    }]);

    return Util;
})();

Util.helpers = {};

exports.default = Util;
},{}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fetch = require('../bower_components/fetch/fetch.js');

var _fetch2 = _interopRequireDefault(_fetch);

var _sha = require('../bower_components/SHA-1/sha1.js');

var _sha2 = _interopRequireDefault(_sha);

var _qs = require('../bower_components/qs/src/qs.js');

var _qs2 = _interopRequireDefault(_qs);

var _fetch3 = require('./fetch');

var _fetch4 = _interopRequireDefault(_fetch3);

var _Util = require('./Util');

var _Util2 = _interopRequireDefault(_Util);

var _Translator = require('./Translator');

var _Translator2 = _interopRequireDefault(_Translator);

var _NoopProvider = require('./provider/NoopProvider');

var _NoopProvider2 = _interopRequireDefault(_NoopProvider);

var _YandexProvider = require('./provider/YandexProvider');

var _YandexProvider2 = _interopRequireDefault(_YandexProvider);

var _GoogleProvider = require('./provider/GoogleProvider');

var _GoogleProvider2 = _interopRequireDefault(_GoogleProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_fetch4.default.setHelper(_fetch2.default);

_Util2.default.addHelper('stringify', _qs2.default.stringify);
_Util2.default.addHelper('sha1', _sha2.default);

_Translator2.default.addProvider('noop', _NoopProvider2.default);
_Translator2.default.addProvider('yandex', _YandexProvider2.default);
_Translator2.default.addProvider('google', _GoogleProvider2.default);

window.doTranslate = {
    Translator: _Translator2.default,
    Util: _Util2.default,
    NoopProvider: _NoopProvider2.default,
    YandexProvider: _YandexProvider2.default,
    GoogleProvider: _GoogleProvider2.default
};

exports.default = true;
},{"../bower_components/SHA-1/sha1.js":1,"../bower_components/fetch/fetch.js":2,"../bower_components/qs/src/qs.js":3,"./Translator":4,"./Util":5,"./fetch":7,"./provider/GoogleProvider":8,"./provider/NoopProvider":9,"./provider/YandexProvider":10}],7:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var helper = function helper() {};

var fetch = function fetch(uri, data) {
    return helper(uri, data).then(function (response) {
        return response.json();
    });
};

fetch.setHelper = function (fn) {
    helper = fn;
};

fetch.getHelper = function () {
    return helper;
};

exports.default = fetch;
},{}],8:[function(require,module,exports){
'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fetch = require('./../fetch');

var _fetch2 = _interopRequireDefault(_fetch);

var _Util = require('./../Util');

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GoogleProvider = (function () {
    function GoogleProvider(key, uri) {
        _classCallCheck(this, GoogleProvider);

        this.key = key;
        this.uri = uri;
    }

    _createClass(GoogleProvider, [{
        key: 'supports',
        value: function supports(langs, to, from) {
            return langs.indexOf(from) > -1 && langs.indexOf(to) > -1;
        }
    }, {
        key: 'getLangs',
        value: function getLangs() {
            return (0, _fetch2.default)(this.uri + 'languages' + _Util2.default.stringify({ key: this.key })).then(function (response) {
                return response.data.languages.map(function (item) {
                    return item.language;
                });
            });
        }
    }, {
        key: 'translate',
        value: function translate(text, to, from) {
            var data = {
                key: this.key,
                'q': text,
                source: from,
                target: to
            };

            return (0, _fetch2.default)(this.uri + _Util2.default.stringify(data)).then(function (response) {
                return response.data.translations.shift().translatedText;
            });
        }
    }]);

    return GoogleProvider;
})();

exports.default = GoogleProvider;
},{"./../Util":5,"./../fetch":7}],9:[function(require,module,exports){
'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Util = require('./../Util');

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NoopProvider = (function () {
    function NoopProvider(key, uri) {
        _classCallCheck(this, NoopProvider);

        this.key = key;
        this.uri = uri;
    }

    _createClass(NoopProvider, [{
        key: 'supports',
        value: function supports(langs, to, from) {
            var lang = _Util2.default.composeLangsAlias(from, to);

            return [lang].indexOf(lang) > -1;
        }
    }, {
        key: 'getLangs',
        value: function getLangs() {
            return new Promise(function (resolve) {
                setTimeout(function () {
                    resolve(['en-ru', 'ru-en']);
                }, 350);
            });
        }
    }, {
        key: 'translate',
        value: function translate(text, to, from) {
            var lang = _Util2.default.composeLangsAlias(from, to);

            return new Promise(function (resolve) {
                setTimeout(function () {
                    resolve(text + '_' + lang);
                }, 350);
            });
        }
    }]);

    return NoopProvider;
})();

exports.default = NoopProvider;
},{"./../Util":5}],10:[function(require,module,exports){
'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fetch = require('./../fetch');

var _fetch2 = _interopRequireDefault(_fetch);

var _Util = require('./../Util');

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var YandexProvider = (function () {
    function YandexProvider(key, uri) {
        _classCallCheck(this, YandexProvider);

        this.key = key;
        this.uri = uri;
    }

    _createClass(YandexProvider, [{
        key: 'supports',
        value: function supports(langs, to, from) {
            return langs.indexOf(_Util2.default.composeLangsAlias(from, to)) > -1;
        }
    }, {
        key: 'getLangs',
        value: function getLangs() {
            return (0, _fetch2.default)(this.uri + 'getLangs' + _Util2.default.stringify({ key: this.key })).then(function (response) {
                return response.dirs;
            });
        }
    }, {
        key: 'translate',
        value: function translate(text, to, from) {
            var data = {
                key: this.key,
                text: text,
                lang: _Util2.default.composeLangsAlias(from, to)
            };

            return (0, _fetch2.default)(this.uri + 'translate' + _Util2.default.stringify(data)).then(function (response) {
                return response.text.shift();
            });
        }
    }]);

    return YandexProvider;
})();

exports.default = YandexProvider;
},{"./../Util":5,"./../fetch":7}]},{},[6])